SystemOrganization addCategory: 'Parasol-GemStone'!

!CharacterCollection methodsFor: '*Parasol-GemStone' stamp: 'KrisGybels 04/25/2013 11:02'!
fillFrom: aCollection with: aBlock
	"Evaluate aBlock with each of aCollections's elements as the argument.  
	Collect the resulting values into self. Answer self."

	| index |
	index := 0.
	aCollection do: [ :each |
		self at: (index := index + 1) put: (aBlock value: each) ]! !

!CharacterCollection methodsFor: '*Parasol-GemStone' stamp: 'JohanBrichau 08/09/2014 01:27'!
withoutTrailingZeroes

	| last |
	last := self findLast: [ :c | c asciiValue ~= 0 ].
	last = 0 ifTrue: [ ^ '' ].
	^ self copyFrom: 1 to: last! !

!Collection methodsFor: '*Parasol-GemStone' stamp: 'KrisGybels 04/25/2013 11:02'!
collect: aBlock as: aClass
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into an instance of aClass. Answer the resulting collection."

	^(aClass new: self size) fillFrom: self with: aBlock! !

!Collection methodsFor: '*Parasol-GemStone' stamp: 'KrisGybels 04/25/2013 10:57'!
fillFrom: aCollection with: aBlock
	"Evaluate aBlock with each of aCollections's elements as the argument.  
	Collect the resulting values into self. Answer self."

	aCollection do: [ :each |
		self add: (aBlock value: each) ]! !

!ByteArray methodsFor: '*Parasol-GemStone' stamp: 'KrisGybels 04/25/2013 11:00'!
fillFrom: aCollection with: aBlock
	"Evaluate aBlock with each of aCollections's elements as the argument.  
	Collect the resulting values into self. Answer self."

	| index |
	index := 0.
	aCollection do: [ :each |
		self at: (index := index + 1) put: (aBlock value: each) ]! !

!Array methodsFor: '*Parasol-GemStone' stamp: 'KrisGybels 04/25/2013 11:00'!
fillFrom: aCollection with: aBlock
	"Evaluate aBlock with each of aCollections's elements as the argument.  
	Collect the resulting values into self. Answer self."

	| index |
	index := 0.
	aCollection do: [ :each |
		self at: (index := index + 1) put: (aBlock value: each) ]! !

BPSmalltalkPlatform subclass: #BPGemStonePlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-GemStone'!

!BPGemStonePlatform class methodsFor: 'as yet unclassified' stamp: 'JohanBrichau 11/21/2014 17:21'!
initialize
	super initialize! !

!BPGemStonePlatform methodsFor: 'facade' stamp: 'JohanBrichau 09/05/2014 07:30'!
byteArrayFromBase64String: aString

	^ aString  base64Decoded asByteArray! !

!BPGemStonePlatform methodsFor: 'facade' stamp: 'JohanBrichau 09/05/2014 07:34'!
fileDelete: filename
	FileDirectory default deleteFileNamed: filename! !

!BPGemStonePlatform methodsFor: 'facade' stamp: 'JohanBrichau 09/05/2014 07:42'!
handleRequest: aBlock

	| response contents|
	response := aBlock value.
	contents := response contents.
	^(BPHttpResponse new)
		httpStatus: response status ;
		headers: response headers;
		contents: contents;
		yourself! !

!BPGemStonePlatform methodsFor: 'facade' stamp: 'JohanBrichau 09/05/2014 07:31'!
httpClient

	^ ZnClient new beOneShot; followRedirects: false; yourself.! !

!BPGemStonePlatform methodsFor: 'tests' stamp: 'JohanBrichau 06/08/2014 22:35'!
httpClientClass
	^ZnClient! !

!BPGemStonePlatform methodsFor: 'performing' stamp: 'JohanBrichau 09/05/2014 07:33'!
httpDelete: url

	^self handleRequest: [ self httpClient url: url; delete; response ]! !

!BPGemStonePlatform methodsFor: 'tests' stamp: 'JohanBrichau 06/08/2014 22:35'!
httpEntityClass
	^ZnEntity! !

!BPGemStonePlatform methodsFor: 'performing' stamp: 'JohanBrichau 09/05/2014 07:34'!
httpGet: url
	System commitTransaction ifFalse:[self error: 'Parasol error: commitTransaction failed.'].
	[ ^ self handleRequest: [ self httpClient url: url; get; response ] ] ensure: [ System continueTransaction ifFalse:[self error: 'Parasol error: continueTransaction failed.'].]! !

!BPGemStonePlatform methodsFor: 'performing' stamp: 'JohanBrichau 09/05/2014 07:36'!
httpPost: url data: data timeout: seconds
	System commitTransaction ifFalse:[self error: 'Parasol error: commitTransaction failed.'].
	[ 

	| data2 httpClient response |
	data2 := ZnEntity with: data
				type: (ZnMimeType main: 'application' sub: 'json') setCharSetUTF8.
	httpClient := self httpClient.
	seconds isNil ifFalse: [httpClient timeout: seconds].
	response := httpClient
				url: (ZnUrl fromString: url);
				entity: data2;
				post;
				response.
	^self handleRequest: [ response ]
] ensure: [ System continueTransaction ifFalse:[self error: 'Parasol error: continueTransaction failed.'].]! !

!BPGemStonePlatform methodsFor: 'facade' stamp: 'JohanBrichau 09/05/2014 07:30'!
jsonRead: aString 
	^JSJsonParser parse: aString! !

!BPGemStonePlatform methodsFor: 'facade' stamp: 'JohanBrichau 09/05/2014 07:30'!
jsonWrite: anObject

	^anObject asJson! !

!BPGemStonePlatform methodsFor: 'tests' stamp: 'JohanBrichau 06/08/2014 22:34'!
mimeTypeClass
	^ZnMimeType! !

!BPGemStonePlatform methodsFor: 'tests' stamp: 'JohanBrichau 06/08/2014 22:34'!
name
	^'GemStone'! !

!BPGemStonePlatform methodsFor: 'facade' stamp: 'JohanBrichau 09/05/2014 07:32'!
pngImageFromByteArray: aByteArray
	self error: 'not yet'! !

!BPGemStonePlatform methodsFor: 'tests' stamp: 'JohanBrichau 07/04/2014 04:40'!
port
	^ WAGemStoneRunSeasideGems default ports first! !

!BPGemStonePlatform methodsFor: 'tests' stamp: 'JohanBrichau 06/08/2014 22:34'!
urlClass
	^ZnUrl! !

!BPGemStonePlatform methodsFor: 'tests' stamp: 'JohanBrichau 06/08/2014 22:34'!
urlFor: aString
	^ZnUrl fromString: aString! !
BPGemStonePlatform initialize!
